package itso.mqe.chatwindow;

/**
 * Insert the type's description here.
 * Creation date: (9/17/2001 3:57:02 PM)
 * @author: Administrator
 */
 import javax.swing.*;
 import java.awt.*;
import java.awt.event.*;
 import com.ibm.mqe.*;
 import itso.mqe.chatserver.*;
 import itso.mqe.chatclient.*;
public class RoomWindow {
	  private JPanel pane = null;
	  private JPanel buttonPane = null;
	  private JPanel textPane = null;

	 private       JTextArea ta = null;
	 private JTextField crInputField = null;
	 private JTextField crInputFieldWas = null;
     private MQeQueueManager qmgr = null;
	 private RoomMgr controller = null;
	 private ClientMgr clientController = null;
	 //private JTextPanel tp = null; 

    final String eol = System.getProperty("line.separator");    

/**
 * RoomWindow constructor comment.
 */
public RoomWindow() {
	super();
}
/**
 * RoomWindow constructor comment.
 */
public RoomWindow(ClientMgr appl) {
	super();
	clientController = appl;
}
/**
 * RoomWindow constructor comment.
 */
public RoomWindow(RoomMgr appl) {
	super();
	controller = appl;
}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 4:06:12 PM)
 * @return java.awt.Component
 */
public Component createComponents() {
	
        final JLabel label = new JLabel("ITSO Chat Room");
        final JLabel label2 = new JLabel("Chat Direct");
        final JLabel label3 = new JLabel("Chat Via WebSphere");


//        label.setLabelFor(button);
      
		JScrollPane sp = new JScrollPane();
        //JTextArea ta = new JTextArea();
        ta = new JTextArea();
        //ta.append("abc");
        ta.setEditable(false);

        JViewport vport = sp.getViewport();
        vport.add(ta);
     

        crInputField = new JTextField(50);
        crInputFieldWas = new JTextField(50);
        if (clientController == null) crInputField.setEditable(false);


        /*
         * An easy way to put space between a top-level container
         * and its contents is to put the contents in a JPanel
         * that has an "empty" border.
         */
        //JPanel pane = new JPanel();
        pane = new JPanel();
        buttonPane = new JPanel();
        textPane = new JPanel();

        pane.setBackground(new java.awt.Color(232,210,186));
        buttonPane.setBackground(new java.awt.Color(27,187,174));
        textPane.setBackground(new java.awt.Color(232,210,186));
      //  pane.setTitle("MQSeries Everyplace Server");
        pane.setBorder(BorderFactory.createEmptyBorder(
                                        30, //top
                                        30, //left
                                        10, //bottom
                                        30) //right
                                        );
        pane.setLayout(new GridLayout(0, 1));
        buttonPane.setLayout(new GridLayout(0, 1));
        textPane.setLayout(new GridLayout(0, 1));

        pane.add(label);
        
        pane.add(sp);

        pane.add(textPane);
        textPane.add(label2);
        textPane.add(crInputField);
        textPane.add(label3);
        textPane.add(crInputFieldWas);
        
        if (controller == null) {
       		 JButton button = new JButton("Trigger Message Transmission");
       		 button.setBackground(new java.awt.Color(27,187,174));
       		 button.setMnemonic(KeyEvent.VK_I);
        	button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //numClicks++;
               // label.setText("Hello");
                System.out.println("Trying triggerSend");
                clientController.triggerSend();
            }
        });

        pane.add(buttonPane); 
        buttonPane.add(button);

   		 JButton button2 = new JButton("Display Admin GUI");
   		 button2.setBackground(new java.awt.Color(27,187,174));
       		 button2.setMnemonic(KeyEvent.VK_I);
        	button2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //numClicks++;
                label.setText("Hello");
                System.out.println("show Admin GUI");
                clientController.showAdminGui();
            }
        });
        
        buttonPane.add(button2);

         JButton button3 = new JButton("YourCo Secure Query");
         button3.setBackground(new java.awt.Color(27,187,174));
       		 button3.setMnemonic(KeyEvent.VK_I);
        	button3.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                //numClicks++;
                label.setText("Hello");
                System.out.println("Cone of Silence");
                clientController.yourCoQuery();
            }
        });
        
        buttonPane.add(button3);
        
        }

        return pane;
    
}
/**
 * Insert the method's description here.
 * Creation date: (9/19/2001 11:50:31 AM)
 */
public void enableInput() {
	crInputField.setEditable(true);
	}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 5:28:39 PM)
 */
public void sendChatMsg() {

    crInputField.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ae) {
            String line = crInputField.getText();
            if (line.length() == 0)
                return;
            //mOut.println(mName + " : " + line);
            crInputField.setText("");
            // need if tets here to determine oif client of controller
            if (clientController == null)
                controller.sendMessage(null, line);
            else
                clientController.sendMessage(null, line);
            ta.append("Sent: " + line + eol);

            ta.setCaretPosition(ta.getDocument().getLength());

        }
    });

}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 9:47:28 AM)
 */
public void setupDirectInputListener() {
	    crInputField.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ae) {
            String line = crInputField.getText();
            if (line.length() == 0)
                return;
            //mOut.println(mName + " : " + line);
            crInputField.setText("");
            // need if tets here to determine oif client of controller
            if (clientController == null)
                controller.sendMessage(null, line);
            else
                clientController.sendMessage(null, line);
            ta.append("Sent: " + line + eol);

            ta.setCaretPosition(ta.getDocument().getLength());

        }
    });

	
	}
/**
 * Insert the method's description here.
 * Creation date: (9/25/2001 7:48:24 PM)
 */
public void setupWasInputListener() {
    crInputFieldWas.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ae) {
            String line = crInputFieldWas.getText();
            if (line.length() == 0)
                return;
            //mOut.println(mName + " : " + line);
            crInputFieldWas.setText("");
            // need if tets here to determine oif client of controller
            if (clientController == null)
                controller.sendMessage("ViaWAS",line);
            else
                clientController.sendMessage("ViaWas", line);
            ta.append("Sent: " + line + eol);

            ta.setCaretPosition(ta.getDocument().getLength());

        }
    });
	}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 4:03:35 PM)
 */
public void showChatWindow() {
		System.out.println("Starting showChatWindow...");
		JFrame frame = null;
        //Create the top-level container and add contents to it.
 		if (clientController == null)
      	  frame = new JFrame("MQSeries Everyplace Server");
        else
            frame = new JFrame("MQSeries Everyplace Client");
       // RoomWindow app = new RoomWindow();
        //Component contents = app.createComponents();
        Component contents = this.createComponents();
        
        frame.getContentPane().add(contents, BorderLayout.CENTER);

        //Finish setting up the frame, and show it.
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        frame.pack();
        frame.setVisible(true);
        System.out.println("Leaving showChatWindow...");
	}
/**
 * Insert the method's description here.
 * Creation date: (9/17/2001 4:38:44 PM)
 * @param receivedMsg java.lang.String
 */
public void showReceivedMsg(String receivedMsg) {
	ta.append(receivedMsg + eol);
	
    ta.setCaretPosition(
            ta.getDocument().getLength());

	}
}
