package itso.mqe.chatclient;

/**
 * Insert the type's description here.
 * Creation date: (9/18/2001 12:05:23 PM)
 * @author: Administrator
 */
import com.ibm.mqe.*;
import com.ibm.mqe.registry.*;
import com.ibm.mqe.administration.*;
import com.ibm.mqe.adapters.*;
import  examples.administration.console.*;
import java.io.*;
import  java.util.*;
public class ClientQm extends MQe implements MQeMessageListenerInterface{

	MQeQueueManager qMgr = null;
    public final static String      Section_QueueManager = "QueueManager";
    public final static String      Section_Alias        = "Alias";
    protected Admin              adminGUI   = null;

	ClientMgr theClientMgr = null; 
  
	/* Following are default values associated with the chat room application */
	
    String clientIniFile = "C:\\ES02WAS\\ClientQm.ini";
   
    String clientQmgrId = "ClientQm";
    
    String destQueue = "ChatRoomQ";
    String destQueueAsync = "ChatRoomQAsync";
    String destQMgr = "ServerQm";

    String destQueueViaWas = "ChatRoomQViaWas";
    String destQueueAsyncViaWas = "ChatRoomQAsyncViaWas";
    String destQMgrViaWas = "ServerQmViaWas";
    
    String clientQueue = "ChatClientQ";
    String eventQMgr = null;
    String eventQueueName = null;
    String originQMgr = null;
 
    String WASIpAddr = null;
 	
/**
 * ClientQm constructor comment.
 */
public ClientQm() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (9/23/2001 3:01:03 PM)
 */
public void addConnection() {
	String remoteQMgr = "WASServerQm";
	String adapter		= "com.ibm.mqe.adapters.MQeTcpipHttpAdapter:9.24.106.53:80";
	String paramaters	= "/ITSO/ITSOMQeWas";
	String options 		= "";
	String channel		= "com.ibm.mqe.MQeChannel";
	String description	= "client chl conn HTTP";

	try {
	MQeConnectionAdminMsg msg = new MQeConnectionAdminMsg();

	msg.setTargetQMgr("ClientQm");

	System.out.println("Cre Con - starting: ");
	msg.setName(remoteQMgr);
		System.out.println("Cre Con - setName done: ");
		System.out.println("Cre Con - doing : " + MQe.Admin_Queue_Name);
	msg.putInt(MQe.Msg_Style,MQe.Msg_Style_Request);
	msg.putAscii(MQe.Msg_ReplyToQ,MQe.Admin_Reply_Queue_Name);
	msg.putAscii(MQe.Msg_ReplyToQMgr, "ClientQm");
	msg.create(adapter, paramaters, options, channel, description);

	System.out.println("Cre Con: " + MQe.Admin_Queue_Name);
	qMgr.putMessage("ClientQm", MQe.Admin_Queue_Name, msg,null, 0);
	}
	catch (Exception e) {
		System.out.println("Connection creation failed: " + e);
	}
	}
/**
 * Insert the method's description here.
 * Creation date: (9/23/2001 3:01:03 PM)
 */
public void addConnection(String WASIpAddr) {
	String remoteQMgr = "WASServerQm";
	String adapter		= "com.ibm.mqe.adapters.MQeTcpipHttpAdapter:" + 
		 					WASIpAddr + ":80";
	String paramaters	= "/ITSO/ITSOMQeWas";
	String options 		= "";
	String channel		= "com.ibm.mqe.MQeChannel";
	String description	= "client chl conn HTTP";

	try {
	MQeConnectionAdminMsg msg = new MQeConnectionAdminMsg();

	msg.setTargetQMgr("ClientQm");

	System.out.println("Cre Con - starting: ");
	msg.setName(remoteQMgr);
		System.out.println("Cre Con - setName done: ");
		System.out.println("Cre Con - doing : " + MQe.Admin_Queue_Name);
	msg.putInt(MQe.Msg_Style,MQe.Msg_Style_Request);
	msg.putAscii(MQe.Msg_ReplyToQ,MQe.Admin_Reply_Queue_Name);
	msg.putAscii(MQe.Msg_ReplyToQMgr, "ClientQm");
	msg.create(adapter, paramaters, options, channel, description);

	System.out.println("Cre Con: " + MQe.Admin_Queue_Name);
	qMgr.putMessage("ClientQm", MQe.Admin_Queue_Name, msg,null, 0);
	}
	catch (Exception e) {
		System.out.println("Connection creation failed: " + e);
	}
	}
/**
 * Insert the method's description here.
 * Creation date: (9/23/2001 4:32:13 PM)
 */
public void addQueue() {
	String remoteQMgr = "WASServerQm";
	String adapter		= "Network:9.24.104.13:80";
	String paramaters	= "/ITSO/ITSOMQeWas";
	String options 		= null;
	String channel		= null;
	String description	= "client chl conn HTTP";

	try {
	MQeRemoteQueueAdminMsg msg = new MQeRemoteQueueAdminMsg();

	msg.setTargetQMgr("ClientQm");

	System.out.println("Cre Que - starting: ");
	msg.setName(remoteQMgr,"ChatRoomQ");
		System.out.println("Cre Que - setName done: ");
	MQeFields parms = new MQeFields();
	parms.putByte(MQeQueueAdminMsg.Queue_Mode,
		          MQeQueueAdminMsg.Queue_Synchronous);
		System.out.println("Cre Que - doing : " + MQe.Admin_Queue_Name);
	msg.putInt(MQe.Msg_Style,MQe.Msg_Style_Request);
	msg.putAscii(MQe.Msg_ReplyToQ,MQe.Admin_Reply_Queue_Name);
	msg.putAscii(MQe.Msg_ReplyToQMgr, "ClientQm");
	msg.create(parms);

	System.out.println("Cre Que: " + MQe.Admin_Queue_Name);
	qMgr.putMessage("ClientQm", MQe.Admin_Queue_Name, msg,null, 0);
	}
	catch (Exception e) {
		System.out.println("Queue creation failed: " + e);
	}
	}
/**
 * Insert the method's description here.
 * Creation date: (9/23/2001 4:32:13 PM)
 */
public void addQueue(String qName, byte mode) {
	String remoteQMgr = "WASServerQm";
	String adapter		= "Network:9.24.104.13:80";
	String paramaters	= "/ITSO/ITSOMQeWas";
	String options 		= null;
	String channel		= null;
	String description	= "client chl conn HTTP";
	

	try {
	MQeRemoteQueueAdminMsg msg = new MQeRemoteQueueAdminMsg();

	msg.setTargetQMgr("ClientQm");

	System.out.println("Creating queue defn: " + qName);
	msg.setName(remoteQMgr, qName);
		System.out.println("Cre Que - setName done: ");
	MQeFields parms = new MQeFields();
	parms.putByte(MQeQueueAdminMsg.Queue_Mode, mode );
	//	          MQeQueueAdminMsg.Queue_Synchronous);
		System.out.println("Cre Que - doing : " + MQe.Admin_Queue_Name);
	msg.putInt(MQe.Msg_Style,MQe.Msg_Style_Request);
	msg.putAscii(MQe.Msg_ReplyToQ,MQe.Admin_Reply_Queue_Name);
	msg.putAscii(MQe.Msg_ReplyToQMgr, "ClientQm");
	msg.create(parms);

	System.out.println("Cre Que: " + MQe.Admin_Queue_Name);
	qMgr.putMessage("ClientQm", MQe.Admin_Queue_Name, msg,null, 0);
	}
	catch (Exception e) {
		System.out.println("Queue creation failed: " + e);
	}
	}
/**
 * Insert the method's description here.
 * Creation date: (9/23/2001 4:32:13 PM)
 */
public void addQueue(String qName, String mode) {
	String remoteQMgr = "WASServerQm";
	String adapter		= "Network:9.24.104.13:80";
	String paramaters	= "/ITSO/ITSOMQeWas";
	String options 		= null;
	String channel		= null;
	String description	= "client chl conn HTTP";
	byte mode1 = MQeQueueAdminMsg.Queue_Synchronous;

	try {
	MQeRemoteQueueAdminMsg msg = new MQeRemoteQueueAdminMsg();

	msg.setTargetQMgr("ClientQm");

	System.out.println("Cre Que - starting: ");
	msg.setName(remoteQMgr, qName);
		System.out.println("Cre Que - setName done: ");
	MQeFields parms = new MQeFields();
	parms.putByte(MQeQueueAdminMsg.Queue_Mode,
		          MQeQueueAdminMsg.Queue_Synchronous);
		System.out.println("Cre Que - doing : " + MQe.Admin_Queue_Name);
	msg.putInt(MQe.Msg_Style,MQe.Msg_Style_Request);
	msg.putAscii(MQe.Msg_ReplyToQ,MQe.Admin_Reply_Queue_Name);
	msg.putAscii(MQe.Msg_ReplyToQMgr, "ClientQm");
	msg.create(parms);

	System.out.println("Cre Que: " + MQe.Admin_Queue_Name);
	qMgr.putMessage("ClientQm", MQe.Admin_Queue_Name, msg,null, 0);
	}
	catch (Exception e) {
		System.out.println("Queue creation failed: " + e);
	}
	}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 9:05:14 AM)
 * @return boolean
 */
public boolean getStartupParms() {

	/* This method is called to read property values associated with the
	   queue manager */

	/* Property file name mys be 'clientChat.property */
	 
    String ejbProperty = null;
    String chatPropName = "clientChat";

    try {
        PropertyResourceBundle resourceBundle =
            (PropertyResourceBundle) PropertyResourceBundle.getBundle(chatPropName);

        clientIniFile = resourceBundle.getString("iniFile");
        clientQueue = resourceBundle.getString("clientQueue");
        destQueue = resourceBundle.getString("destQueue");
        destQueueAsync = resourceBundle.getString("destQueueAsync");
        destQMgr = resourceBundle.getString("destQMgr");
        clientQmgrId = resourceBundle.getString("clientQm");
        WASIpAddr = resourceBundle.getString("WASIpAddr");

        return true;

    } catch (Exception e) {

        System.out.println((new java.util.Date()) + " Error getting a property " + e);
        return false;

    }

}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 8:37:22 AM)
 * @param e com.ibm.mqe.MQeMessageEvent
 */
public void messageArrived(MQeMessageEvent e) {
	
	eventQMgr = e.getQueueManagerName();	/*get id of Qmgr msg from */
	eventQueueName = e.getQueueName();		/*get queue name */

	try {

	/* get the message */
		
	MQeMsgObject msgObj = qMgr.getMessage(null, clientQueue, null, null, 0);	
	
	originQMgr = msgObj.getOriginQMgr();
	System.out.println("From: " + originQMgr +
						" : " + eventQueueName + 
						" msg: " + msgObj.getAscii("Message"));

	/* Call method in the chat applicaton to show the message in the
	   GUI window */
	
	theClientMgr.showReceivedMsg("From: " + originQMgr + 
						" : " + msgObj.getAscii("Message"));
	}
	catch (MQeException ex){
		System.out.println("MQe error getting msg" + ex);
	}
	catch (Exception ex){
		System.out.println("Error getting msg" + ex);
	}
	}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 9:23:04 AM)
 * @param viaWasFlag java.lang.String
 * @param message java.lang.String
 */
public void sendMessage(String viaWasFlag, String message) {
    String targQ = null;
    String targQAsync = null;
    String targQMgr = null;

	/* The action listener that is invoked when the Enter key is
	   pressed in a text box, sets the  value of viaWasFlag when it calls 
	   this method.
	   
	   The value is null if called from the listener for the 'Chat Direct' 
	   box, and not null if called from the listener for the 
	   'Chat via WebSphere' box */
    
    if (viaWasFlag == null) {
        targQ = destQueue;
        targQMgr = destQMgr;
        targQAsync = destQueueAsync;
    } else {
        MQeWESAuthenticationAdapter.setBasicAuthorization("USERID", "PASSWORD");
        targQ = destQueueViaWas;
        targQMgr = destQMgrViaWas;
        targQAsync = destQueueAsyncViaWas;
    }

    try {
        MQeMsgObject msgObj = new MQeMsgObject();

        try {
            System.out.println("Msg to send: " + message);

            msgObj.putAscii("Message", message); /* set up the message */

            System.out.println(
                "Send to: " + targQMgr + " destQ: " + targQ + "doing PUT: " + message);

            /* If the string 'Stress Test' do not appear in the text typed 
               in, then put the message to the queue to have it sent
               synchronously.
               When the 'Stress Test' string is found, invoke a method 
               to handle that case */
               
            if (message.indexOf("Stress Test") < 0)
                qMgr.putMessage(targQMgr, targQ, msgObj, null, 0);
            else
                stressTest(viaWasFlag, message);

            System.out.println(
                "Sent to: " + destQMgr + " : " + " msg: " + msgObj.getAscii("Message"));
        } catch (Exception ex) {

	        /* If an exception occurs as a result of the put message
	           attempt, put the message to the alternate queue to have
	           the message sent asynchronously */
	           
	        System.out.println("Error sending msg" + ex);
            theClientMgr.showReceivedMsg(
                "## Chat room server unavailable"
                    + " will attempt to send message asynchronously ##");

            msgObj.resetMsgUIDFields();
            
            try {
                System.out.println(
                    "Async Send to: " + targQMgr + " destQ: "
                        + targQAsync + "doing PUT: " + message);

                qMgr.putMessage(targQMgr, targQAsync, msgObj, null, 0);

                theClientMgr.showReceivedMsg(
                    "## Message saved, will be sent Asynchonously ##");

            } catch (Exception ex2) {
                theClientMgr.showReceivedMsg("## Catastrophic failure, async PUT failed ##");
                System.out.println("Error doing Async PUT" + ex2);
            }
        }
    } catch (Exception ex3) {
        System.out.println("Error creating msgObj" + ex3);
    }
	}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 9:50:15 AM)
 */
public void showAdminGui() {

	/* This method results in the supplied sample Admin GUI tool being
	   displayed */
	   
	try{
	
	adminGUI = (Admin)MQe.loader.loadObject("Admin");
     adminGUI.activate();
	}
	catch (Exception e){
		System.out.println("Error loading Admin GUI" + e);
	}
	}
/**
 * Insert the method's description here.
 * Creation date: (9/18/2001 12:08:00 PM)
 * @param queueMgrid java.lang.String
 * @param iniFile java.lang.String
 */
public void startClientQm(ClientMgr clientMgr) {

    /* Save reference to the one that called this object */

    theClientMgr = clientMgr;

    /* Read queue manager related properties if flag set */

    if (clientMgr.readProps)
        if (!getStartupParms()) {
            System.out.println("Error reading property file");
            //  return null;
        }

    System.out.println("..Start a queue manager using ini file: " + clientIniFile);
    try {

        /* The following code was extracted from the supplied sample code
            that is suplied with MQSeries Everyplace.  The code was in
            a method called loadConfigFile in
            mqe\java\examples\queuemanager\MQeQueueManagerUtils.java */

        // Access the file
        File diskFile = new File(clientIniFile);

        // Create a byte array big enough to hold the file's contents.
        byte data[] = new byte[(int) diskFile.length()];

        // Read the file into the byte array and close the file.
        FileInputStream inputFile = new FileInputStream(diskFile);
        inputFile.read(data);
        inputFile.close();

        // Read the data into a buffer where it can be manipulated.
        StringBuffer configDataBuff = new StringBuffer(byteToAscii(data));

        // We want to look for single \n characters which are not adjacent to \r
        // characters. ie; On Unix systems, if someone uses vi or similar editor 
        // to edit the .ini file, then lines will end in \n only.
        // To make MQe more tolerant of this, we convert lone \n characters to \r\n
        // sequences so the .ini files can cope.
        // This has the side-effect of dis-allowing embedded \n characters in an .ini
        // file, but this compromise is seen as being acceptable.

        // Method: Work through all the configuration information. 
        // If we find a single \n character, insert a \r character before it.
        char prevChar = '\0';
        char thisChar = '\0';
        for (int along = 0; along < configDataBuff.length(); along += 1) {
            prevChar = thisChar;
            thisChar = configDataBuff.charAt(along);
            if ((thisChar == '\n') && (prevChar != '\r')) {
                // The character under strutiny was a '\n' on it's own.
                // Turn it into a '\r\n'
                configDataBuff.insert(along, '\r');
                // Skip the along counter on one, so we don't look at the same
                // '\n' character again.
                along += 1;
            } else {
                // The character under scrutiny was not a '\n' on it's own, 
                //  so just leave it alone. 
            }
        }

            MQeFields iniSections =
                MQeFields.restoreFromString("\r\n", // end of record string
    		    "[#0]", // section pattern
   			     "(#0)#1=#2", // keyword pattern
 				   configDataBuff.toString() + "\r\n");

        /* Create queue manager object */

        qMgr = new MQeQueueManager();

        if (iniSections.contains(Section_Alias)) {

            // Get all the fields inside the alias section
            MQeFields section = iniSections.getFields(Section_Alias);
            Enumeration keys = section.fields();
            while (keys.hasMoreElements()) {

                // For each key, get the value and add the mapping to the MQe
                // internal alias table
                String key = (String) keys.nextElement();

                MQe.alias(key, section.getAscii(key).trim());

                System.out.println("Key: " + key + " Val: " + section.getAscii(key).trim());
            }

            //    sectionProcessed(Section_Alias);
        }

        /* Alias definition entries have been set up, now actually try to
           activate the queue manager */

        if (iniSections.contains(Section_QueueManager)) {
            qMgr = (MQeQueueManager) MQe.loader.loadObject(Section_QueueManager);
            if (qMgr != null) {

                // Activate the queue manager.
 
                qMgr.activate(iniSections);

                // Processing was successful.
            }
        }

        if (WASIpAddr != "") {
            //	addConnection(WASIpAddr);
            //addQueue("ChatRoomQViaWas", MQeQueueAdminMsg.Queue_Synchronous );
            //addQueue("ChatRoomQViaWasAsync", MQeQueueAdminMsg.Queue_Asynchronous );
        }

        String qMgrName = qMgr.getName();

        System.out.println("..Started queue manager: " + qMgrName);

        /* Now that the queue manager has started, add a listener for
           the queue will receive chat messages on, when a message arrives,
           this listener will invoke the messageArrived method in this object */

        try {
            /* Create a message listener for incoming messages */

            qMgr.addMessageListener(this, clientQueue, null);

        } catch (Exception e) {
			System.out.println("Add msg listener failed: " + e);
        }
    } catch (Exception ex) {
        System.out.println("..Start of queue manager failed: " + ex);

    }
}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 9:26:05 AM)
 * @param viaWasFlag java.lang.String
 * @param stressMsg java.lang.String
 */
public void stressTest(String viaWasFlag, String stressMsg) {

	/* This is a very simple stress test method, to just send a number
	   of largish messages to a queue manager, and determine how long
	   it took. */
	
	String targQ = null;
	String targQAsync = null;
	String targQMgr = null;
	String stressQ = "StressQ";
	String stressQMgr = "";
	
	if (viaWasFlag == null) {
		targQ = destQueue;
		targQMgr = destQMgr;
		stressQMgr = destQMgr;
		targQAsync = destQueueAsync;
	}
	else {
		targQ = destQueueViaWas;
		targQMgr = destQMgrViaWas;
		stressQMgr = "WASServerQm";
		targQAsync = destQueueAsyncViaWas;
	}
    try {
		int sendCnt = 10;
	    MQeMsgObject msgObj = new MQeMsgObject();

		String bigMessage = "NODISPLAY: Despite the impression given by television, " +
						"spiders, snakes and crocodiles are not a major " +
						"threat to life and limb" +
						", not even a minor threat";
        try {
            System.out.println("Start stress test...");

            
            msgObj.putAscii("Message", bigMessage); /* set up the message */

            Date stressStart = new Date();
 			for (int ii = 1; ii < sendCnt; ii++){
            qMgr.putMessage(stressQMgr, stressQ, msgObj, null, 0);
            msgObj.resetMsgUIDFields();}
           
            long sendTimeMs = new Date().getTime() - stressStart.getTime();

            String resultMsg = sendCnt + " Messages, each of length: " + bigMessage.length()
            			+ " sent in " + sendTimeMs + " (ms)";
 
   			msgObj.putAscii("Message", resultMsg);
            qMgr.putMessage(targQMgr, targQ, msgObj, null, 0);

            theClientMgr.showReceivedMsg(resultMsg);

            msgObj.resetMsgUIDFields();

            int bytesSent  = bigMessage.length() * sendCnt;
			double rate = ((double)bytesSent / (double)sendTimeMs ) * 1000;
            resultMsg = "Total bytes: " + bytesSent 
			           + " throughput rate: " + rate + " (bytes/sec)";

			msgObj.putAscii("Message", resultMsg);
            qMgr.putMessage(targQMgr, targQ, msgObj, null, 0);

            theClientMgr.showReceivedMsg(resultMsg);
     
        } catch (MQeException ex) {
            System.out.println("MQe Error sending msg" + ex);
        } catch (Exception ex) {
            System.out.println("Error sending msg" + ex);
        }
    } catch (Exception ex3) {
        System.out.println("Error creating msgObj" + ex3);
    }	
	
	}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 10:06:02 AM)
 */
public void triggerSend() {

	/* This method will cause the queue manager to:

		- send any messages waiting to be sent asynchronously
		- poll and store and forward queues on connected remote
		  queue managers */
		  
	System.out.println("Triggering queue manager...");
	try {
	qMgr.triggerTransmission();
	}
	catch (Exception e){
		System.out.println("Triggering failed" + e);
		}
	}
/**
 * Insert the method's description here.
 * Creation date: (10/1/2001 9:51:50 AM)
 */
public void yourCoQuery() {

	/* This method demonstrates how MQSeries Everyplace can be used
	   extend an application that may have been only previously been
	   accessed via HTTP from a browser */
	   
	String targQ = "YourCoQuery";
	String targQAsync = null;
	String targQMgr = "WASServerQm";

    try {
        MQeMsgObject msgObj = new MQeMsgObject();

        try {
    
            msgObj.putAscii("Message", "Total Leave Summary"); /* set up the message */

            System.out.println(
                "Send to: " + targQMgr + " destQ: " + targQ + "doing PUT: ");

            qMgr.putMessage(targQMgr, targQ, msgObj, null, 0);

        } catch (MQeException ex) {
            System.out.println("MQe Error sending YourCo msg" + ex);
        } catch (Exception ex) {
            System.out.println("Error sending YourCo msg" + ex);
  
        }
    } catch (Exception ex3) {
        System.out.println("Error creating msgObj" + ex3);
    }
	
	}
}
